diff -Naur --exclude=CVS --exclude=configs linux/fs/nfsd/export.c linux-openmosix/fs/nfsd/export.c
--- linux/fs/nfsd/export.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/nfsd/export.c	2004-02-05 10:51:22.000000000 +0100
@@ -487,6 +487,9 @@
 		return 0;
 	}
 
+#ifdef CONFIG_MOSIX
+	current->mosix.ignoreoldsigs = 1;
+#endif /* CONFIG_MOSIX */
 	current->sigpending = 0;
 	want_lock++;
 	while (hash_count || hash_lock) {
diff -Naur --exclude=CVS --exclude=configs linux/fs/nfsd/vfs.c linux-openmosix/fs/nfsd/vfs.c
--- linux/fs/nfsd/vfs.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/nfsd/vfs.c	2004-02-05 10:51:22.000000000 +0100
@@ -45,6 +45,10 @@
 
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
 #define NFSDDBG_FACILITY		NFSDDBG_FILEOP
 #define NFSD_PARANOIA
 
@@ -108,6 +112,13 @@
 	dparent = fhp->fh_dentry;
 	exp  = fhp->fh_export;
 
+#ifdef CONFIG_MOSIX_FS
+	if(dparent->d_sb->s_magic == MFS_SUPER_MAGIC)
+	{
+		err = -EPERM;
+		goto out;
+	}
+#endif /* CONFIG_MOSIX_FS */
 	err = nfserr_acces;
 
 	/* Lookup the name, but don't follow links */
@@ -509,6 +520,9 @@
 		filp->f_op->release(inode, filp);
 	fops_put(filp->f_op);
 	if (filp->f_mode & FMODE_WRITE)
+#ifdef CONFIG_MOSIX
+	if (!(filp->f_flags & O_NOWRITEACCESS))
+#endif /* CONFIG_MOSIX */
 		put_write_access(inode);
 }
 
diff -Naur --exclude=CVS --exclude=configs linux/fs/open.c linux-openmosix/fs/open.c
--- linux/fs/open.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/open.c	2004-02-05 10:51:21.000000000 +0100
@@ -20,6 +20,12 @@
 
 #define special_file(m) (S_ISCHR(m)||S_ISBLK(m)||S_ISFIFO(m)||S_ISSOCK(m))
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <hpc/dfsa.h>
+#include <linux/hpc.h>
+#include <hpc/debug.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 int vfs_statfs(struct super_block *sb, struct statfs *buf)
 {
 	int retval = -ENODEV;
@@ -41,8 +47,15 @@
 {
 	struct nameidata nd;
 	int error;
-
+#ifdef CONFIG_MOSIX_FS
+	        nd.express_function = EF_STATFS;
+		nd.complete_args.statfs = buf;
+		error = __user_walk(path, LOOKUP_FOLLOW|LOOKUP_POSITIVE|LOOKUP_COMPLETE, &nd);
+		if(nd.complete_flags & COMPLETE_DONE)
+                return(error);
+#else
 	error = user_path_walk(path, &nd);
+#endif 	
 	if (!error) {
 		struct statfs tmp;
 		error = vfs_statfs(nd.dentry->d_inode->i_sb, &tmp);
@@ -63,7 +76,14 @@
 	file = fget(fd);
 	if (!file)
 		goto out;
+#ifdef CONFIG_MOSIX_FS
+        current->mosix.dirty_bits |= MFSARG_STATFS_FP; /* ?? */
+        current->mosix.dirty_file = file;	
+#endif	
 	error = vfs_statfs(file->f_dentry->d_inode->i_sb, &tmp);
+#ifdef CONFIG_MOSIX_FS
+	current->mosix.dirty_bits &= ~MFSARG_STATFS_FP; /* ?? */
+#endif
 	if (!error && copy_to_user(buf, &tmp, sizeof(struct statfs)))
 		error = -EFAULT;
 	fput(file);
@@ -93,6 +113,10 @@
 		BUG();
 	files->fd[fd] = file;
 	write_unlock(&files->file_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_open_file(fd); /* by Amit Shah */
+	/* leave out for now, but needs to be fixed mosix_rebuild_file_list(); */
+#endif
 }
 
 int do_truncate(struct dentry *dentry, loff_t length)
@@ -125,7 +149,21 @@
 	if (length < 0)	/* sorry, but loff_t says... */
 		goto out;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_TRUNCATE;
+	nd.complete_args.len = length;
+	error = __user_walk(path, LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS|
+							LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(path,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(path, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto out;
 	inode = nd.dentry->d_inode;
@@ -191,6 +229,9 @@
 	error = -EINVAL;
 	if (length < 0)
 		goto out;
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -262,7 +303,21 @@
 	struct inode * inode;
 	struct iattr newattrs;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_UTIME;
+	nd.complete_parg = times;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto out;
 	inode = nd.dentry->d_inode;
@@ -306,7 +361,21 @@
 	struct inode * inode;
 	struct iattr newattrs;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_UTIMES;
+	nd.complete_parg = utimes;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS| LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS , &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 
 	if (error)
 		goto out;
@@ -366,7 +435,22 @@
 	else
 		current->cap_effective = current->cap_permitted;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_ACCESS;
+	nd.complete_args.ints.i1 = mode;
+	res = __user_walk(filename,
+		LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_COMPLETE|LOOKUP_STAYFS,
+									&nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(res);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	res = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	res = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!res) {
 		res = permission(nd.dentry->d_inode, mode);
 		/* SuS v2 requires we report a read only fs too */
@@ -379,6 +463,11 @@
 	current->fsuid = old_fsuid;
 	current->fsgid = old_fsgid;
 	current->cap_effective = old_cap;
+#ifdef CONFIG_MOSIX_DFSA
+	/* a bit paranoid, for the rare case when we slept interruptibly
+	 * during "permission" and the temporary fs[ug]id passed across: */
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	return res;
 }
@@ -388,7 +477,12 @@
 	int error;
 	struct nameidata nd;
 
+#ifdef CONFIG_MOSIX_DFSA
+        error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_DIRECTORY|
+                                                        LOOKUP_STAYFS, &nd);
+#else
 	error = __user_walk(filename,LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_DIRECTORY,&nd);
+#endif /* CONFIG_MOSIX_DFSA */
 	if (error)
 		goto out;
 
@@ -412,6 +506,9 @@
 	struct vfsmount *mnt;
 	int error;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EBADF;
 	file = fget(fd);
 	if (!file)
@@ -469,6 +566,9 @@
 	int err = -EBADF;
 	struct iattr newattrs;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	file = fget(fd);
 	if (!file)
 		goto out;
@@ -501,7 +601,21 @@
 	int error;
 	struct iattr newattrs;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_CHMOD;
+	nd.complete_args.mode = mode;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (error)
 		goto out;
 	inode = nd.dentry->d_inode;
@@ -526,7 +640,11 @@
 	return error;
 }
 
+#ifdef CONFIG_MOSIX_FS
+int chown_common(struct dentry * dentry, uid_t user, gid_t group)
+#else
 static int chown_common(struct dentry * dentry, uid_t user, gid_t group)
+#endif /* CONFIG_MOSIX_FS */
 {
 	struct inode * inode;
 	int error;
@@ -591,7 +709,22 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_CHOWN;
+	nd.complete_args.ids.uid = user;
+	nd.complete_args.ids.gid = group;
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_FOLLOW|
+					LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_FOLLOW|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = chown_common(nd.dentry, user, group);
 		path_release(&nd);
@@ -604,7 +737,21 @@
 	struct nameidata nd;
 	int error;
 
+#ifdef CONFIG_MOSIX_FS
+	nd.express_function = EF_CHOWN;
+	nd.complete_args.ids.uid = user;
+	nd.complete_args.ids.gid = group;
+	error = __user_walk(filename,
+			LOOKUP_POSITIVE|LOOKUP_STAYFS|LOOKUP_COMPLETE, &nd);
+	if(nd.complete_flags & COMPLETE_DONE)
+		return(error);
+#else
+#ifdef CONFIG_MOSIX_DFSA
+	error = __user_walk(filename, LOOKUP_POSITIVE|LOOKUP_STAYFS, &nd);
+#else
 	error = user_path_walk_link(filename, &nd);
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
 	if (!error) {
 		error = chown_common(nd.dentry, user, group);
 		path_release(&nd);
@@ -618,6 +765,9 @@
 	struct file * file;
 	int error = -EBADF;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fd, 0);
+#endif /* CONFIG_MOSIX_DFSA */
 	file = fget(fd);
 	if (file) {
 		error = chown_common(file->f_dentry, user, group);
@@ -644,6 +794,9 @@
 {
 	int namei_flags, error;
 	struct nameidata nd;
+#ifdef CONFIG_MOSIX_FS
+	int old_magic = current->mosix.lastmagic;
+#endif /* CONFIG_MOSIX_FS */
 
 	namei_flags = flags;
 	if ((namei_flags+1) & O_ACCMODE)
@@ -651,9 +804,31 @@
 	if (namei_flags & O_TRUNC)
 		namei_flags |= 2;
 
+#ifdef CONFIG_MOSIX_FS
+	if(flags & O_CREAT)
+		current->mosix.lastmagic = current->mosix.whereami ? : PE;
+#endif /* CONFIG_MOSIX_FS */
 	error = open_namei(filename, namei_flags, mode, &nd);
+#ifdef CONFIG_MOSIX_FS
+	if(!(nd.complete_flags & COMPLETE_MAGICAL))
+		current->mosix.lastmagic = old_magic;
+#endif /* CONFIG_MOSIX_FS */
 	if (!error)
+#ifdef CONFIG_MOSIX_FS
+	{
+		struct file *newf = dentry_open(nd.dentry, nd.mnt, flags);
+
+		if(IS_ERR(newf))
+			current->mosix.lastmagic = old_magic;
+#ifdef CONFIG_MOSIX_DFSA
+		else if(current->mosix.lastmagic != old_magic)
+			current->mosix.dupdates |= DFSA_UPDSEL;
+#endif /* CONFIG_MOSIX_DFSA */
+		return newf;
+	}
+#else
 		return dentry_open(nd.dentry, nd.mnt, flags);
+#endif /* CONFIG_MOSIX_FS */
 
 	return ERR_PTR(error);
 }
@@ -745,6 +920,11 @@
 
 	/* Do we need to expand the fdset array? */
 	if (fd >= files->max_fdset) {
+#ifdef CONFIG_MOSIX_DFSA
+		if(current->mosix.dflags & DREMOTE)
+			error = -EDOITATHOME;
+		else
+#endif /* CONFIG_MOSIX_DFSA */
 		error = expand_fdset(files, fd);
 		if (!error) {
 			error = -EMFILE;
@@ -757,6 +937,11 @@
 	 * Check whether we need to expand the fd array.
 	 */
 	if (fd >= files->max_fds) {
+#ifdef CONFIG_MOSIX_DFSA
+		if(current->mosix.dflags & DREMOTE)
+			error = -EDOITATHOME;
+		else
+#endif /* CONFIG_MOSIX_DFSA */
 		error = expand_fd_array(files, fd);
 		if (!error) {
 			error = -EMFILE;
@@ -795,10 +980,46 @@
 	if (!IS_ERR(tmp)) {
 		fd = get_unused_fd();
 		if (fd >= 0) {
+#ifdef CONFIG_MOSIX_DFSA
+			struct file * f;
+			mode_t imode;
+
+			current->mosix.dirty_bits |= FILP_OPEN_SYSCALL;
+			f = filp_open(tmp, flags, mode);
+			current->mosix.dirty_bits &= ~FILP_OPEN_SYSCALL;
+#else
 			struct file *f = filp_open(tmp, flags, mode);
+#endif /* CONFIG_MOSIX_DFSA */
 			error = PTR_ERR(f);
 			if (IS_ERR(f))
 				goto out_error;
+#ifdef CONFIG_MOSIX_DFSA
+			imode = f->f_dentry->d_inode->i_mode;
+			if(!S_ISREG(imode) && !S_ISDIR(imode))
+			{
+				if(current->mosix.dflags & DREMOTE)
+				{
+#ifdef CONFIG_MOSIX_DEBUG
+					if(ds_debug & DSDEB_DFSA)
+					printk("%d(%s)-File <%s> Did not open, "
+						"mode=%d\n", current->pid,
+						current->comm, tmp, imode);
+#endif /* CONFIG_MOSIX_DEBUG */
+					filp_close(f, NULL);
+					error = -EDOITATHOME;
+					goto out_error;
+				}
+				current->mosix.dflags &= ~DSTATSDOWN;
+			}
+#ifdef CONFIG_MOSIX_DEBUG
+			if((current->mosix.dflags & DREMOTE) &&
+							(ds_debug & DSDEB_DFSA))
+				printk("%d(%s)-Opened <%s> Remotely, fd=%d, "
+					"ino=%ld\n", current->pid,
+					current->comm, tmp, (int)fd,
+					f->f_dentry->d_inode->i_ino);
+#endif /* CONFIG_MOSIX_DEBUG */
+#endif /* CONFIG_MOSIX_DFSA */
 			fd_install(fd, f);
 		}
 out:
@@ -809,6 +1030,10 @@
 out_error:
 	put_unused_fd(fd);
 	fd = error;
+#ifdef CONFIG_MOSIX_DFSA
+	if(error == -ETXTBSY && (current->mosix.dflags & DREMOTE))
+		error = -EDOITATHOME;
+#endif /* CONFIG_MOSIX_DFSA */
 	goto out;
 }
 
@@ -869,6 +1094,9 @@
 	FD_CLR(fd, files->close_on_exec);
 	__put_unused_fd(files, fd);
 	write_unlock(&files->file_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_close_file(fd);
+#endif /* CONFIG_MOSIX_DFSA */
 	return filp_close(filp, files);
 
 out_unlock:
@@ -876,6 +1104,35 @@
 	return -EBADF;
 }
 
+#ifdef CONFIG_MOSIX_DFSA
+/*
+ * almost like "sys_close", except for raising DSTATSDOWN in the right
+ * circumstances, which we cannot do this in "sys_close" itself only
+ * because it can be called from other system-calls.
+ * [wish they all called "do_close" instead!]
+ */
+asmlinkage long sys_close_syscall(unsigned int fd)
+{
+	register struct task_struct *p = current;
+
+	if((p->mosix.dflags & (DDEPUTY|DREMOTE)) || !CAN_DFSA(p))
+		goto call_sys;
+
+	/* no locking of "&p->files->file_lock" is needed because CAN_DFSA
+	 * included checking that no clones are sharing our files! */
+	if (fd >= p->files->max_fds)
+	/* if we were to run remotely, we could also "close" a bad file there!*/
+	{
+		p->mosix.dflags |= DSTATSDOWN;
+		return -EBADF;
+	}
+	if(can_dfsa_file(fd))	/* and we already know CAN_DFSA(p) is true */
+		p->mosix.dflags |= DSTATSDOWN;
+	call_sys:
+	return(sys_close(fd));
+}
+#endif /* CONFIG_MOSIX_DFSA */
+
 /*
  * This routine simulates a hangup on the tty, to arrange that users
  * are given clean terminals at login time.
diff -Naur --exclude=CVS --exclude=configs linux/fs/pipe.c linux-openmosix/fs/pipe.c
--- linux/fs/pipe.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/pipe.c	2004-02-05 10:51:21.000000000 +0100
@@ -69,8 +69,24 @@
 			goto out;
 
 		for (;;) {
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+			unsigned long bytes, prev;
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 			PIPE_WAITING_READERS(*inode)++;
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+			bytes = count;
+			if (bytes > PIPE_BUF)
+				bytes = PIPE_BUF;
+			prev = PIPE_READING_BYTES(*inode);
+			PIPE_READING_BYTES(*inode) += bytes;
+			if (!prev && (PIPE_EXCEPTIONS(*inode) &
+							PIPE_EXCEPTION_INPUT))
+				wake_up_interruptible(PIPE_WAIT(*inode));
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 			pipe_wait(inode);
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+			PIPE_READING_BYTES(*inode) -= bytes;
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 			PIPE_WAITING_READERS(*inode)--;
 			ret = -ERESTARTSYS;
 			if (signal_pending(current))
@@ -259,6 +275,22 @@
 	return -EBADF;
 }
 
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+static inline int
+set_pipe_exceptions(struct inode *ip, unsigned long val)
+{
+	int oval = PIPE_EXCEPTIONS(*ip);
+
+	PIPE_EXCEPTIONS(*ip) = val;
+	if (val & ~(PIPE_EXCEPTION_INPUT|PIPE_EXCEPTION_NOINPUT))
+		return -EINVAL;
+	if (((val & PIPE_EXCEPTION_INPUT & ~oval) && PIPE_READING_BYTES(*ip))
+	    || ((val & PIPE_EXCEPTION_NOINPUT & ~oval) && !PIPE_READERS(*ip)))
+		wake_up_interruptible(PIPE_WAIT(*ip));
+	return 0;
+}
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
+
 static int
 pipe_ioctl(struct inode *pino, struct file *filp,
 	   unsigned int cmd, unsigned long arg)
@@ -266,6 +298,12 @@
 	switch (cmd) {
 		case FIONREAD:
 			return put_user(PIPE_LEN(*pino), (int *)arg);
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+		case TCSBRK:
+			return set_pipe_exceptions(pino, arg);
+		case TIOCGWINSZ:
+			return PIPE_READING_BYTES(*pino);
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 		default:
 			return -EINVAL;
 	}
@@ -288,6 +326,13 @@
 		mask |= POLLHUP;
 	if (!PIPE_READERS(*inode))
 		mask |= POLLERR;
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+	if (((PIPE_EXCEPTIONS(*inode) & PIPE_EXCEPTION_INPUT) &&
+		PIPE_READING_BYTES(*inode)) ||
+	    ((PIPE_EXCEPTIONS(*inode) & PIPE_EXCEPTION_NOINPUT) &&
+		!PIPE_READERS(*inode)))
+		mask |= POLLPRI;
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 
 	return mask;
 }
@@ -453,6 +498,9 @@
 	PIPE_READERS(*inode) = PIPE_WRITERS(*inode) = 0;
 	PIPE_WAITING_READERS(*inode) = PIPE_WAITING_WRITERS(*inode) = 0;
 	PIPE_RCOUNTER(*inode) = PIPE_WCOUNTER(*inode) = 1;
+#ifdef CONFIG_MOSIX_PIPE_EXCEPTIONS
+	PIPE_READING_BYTES(*inode) = PIPE_EXCEPTIONS(*inode) = 0;
+#endif /* CONFIG_MOSIX_PIPE_EXCEPTIONS */
 
 	return inode;
 fail_page:
diff -Naur --exclude=CVS --exclude=configs linux/fs/proc/array.c linux-openmosix/fs/proc/array.c
--- linux/fs/proc/array.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/proc/array.c	2004-02-05 10:51:22.000000000 +0100
@@ -77,6 +77,13 @@
 #include <asm/io.h>
 #include <asm/processor.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#include <linux/ptrace.h>
+#include <linux/smp_lock.h>
+#include <linux/file.h>
+#endif /* CONFIG_MOSIX */
+
 /* Gcc optimizes away "strlen(x)" for constant x */
 #define ADDBUF(buffer, string) \
 do { memcpy(buffer, string, strlen(string)); \
@@ -131,7 +138,12 @@
 
 static inline const char * get_task_state(struct task_struct *tsk)
 {
-	unsigned int state = tsk->state & (TASK_RUNNING |
+#ifdef CONFIG_MOSIX
+	unsigned int state = LOGICAL_STATE(tsk)
+#else
+	unsigned int state = tsk->state
+#endif /* CONFIG_MOSIX */ 
+					& (TASK_RUNNING |
 					   TASK_INTERRUPTIBLE |
 					   TASK_UNINTERRUPTIBLE |
 					   TASK_ZOMBIE |
@@ -177,7 +189,11 @@
 	return buffer;
 }
 
+#ifdef CONFIG_MOSIX
+inline char * task_mem(struct mm_struct *mm, char *buffer)
+#else
 static inline char * task_mem(struct mm_struct *mm, char *buffer)
+#endif /* CONFIG_MOSIX */
 {
 	struct vm_area_struct * vma;
 	unsigned long data = 0, stack = 0;
@@ -278,10 +294,18 @@
 {
 	char * orig = buffer;
 	struct mm_struct *mm;
+#ifdef CONFIG_MOSIX
+	int should_ask = 0;
+#endif /* CONFIG_MOSIX */
 
 	buffer = task_name(task, buffer);
 	buffer = task_state(task, buffer);
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if((should_ask = SHOULD_ASK_PROCESS(task)))
+		mm = NULL;
+	else
+#endif /* CONFIG_MOSIX */
 	mm = task->mm;
 	if(mm)
 		atomic_inc(&mm->mm_users);
@@ -290,6 +314,10 @@
 		buffer = task_mem(mm, buffer);
 		mmput(mm);
 	}
+#ifdef CONFIG_MOSIX
+	else if(should_ask)
+		buffer = request_process_to_buf(task,buffer,PR_PROCFS_TASK_MEM);
+#endif /* CONFIG_MOSIX */
 	buffer = task_sig(task, buffer);
 	buffer = task_cap(task, buffer);
 #if defined(CONFIG_ARCH_S390)
@@ -298,10 +326,153 @@
 	return buffer - orig;
 }
 
+#ifdef CONFIG_MOSIX
+
+int proc_pid_where(struct task_struct *task, char *buffer)
+{
+	task_lock(task);
+	sprintf(buffer, "%d\n", (task->mosix.stay & DSTAY_SYSTEM) ? 0 :
+							task->mosix.whereami);
+	task_unlock(task);
+	return (strlen(buffer));
+}
+
+int proc_pid_lock(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%d\n", (task->mosix.stay & DNOMIGRATE) ? 1 : 0);
+	buffer[2] = '\0';
+	return(2);	/* == strlen(buffer) */
+}
+
+int proc_pid_disclosure(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%d\n", task->mosix.disclosure);
+	return(strlen(buffer));
+}
+
+int proc_pid_migfilter(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%d\n", (task->mosix.dflags & DMIGFILTER) ? 1 : 0);
+	buffer[2] = '\0';
+	return(2);	/* == strlen(buffer) */
+}
+
+int proc_pid_migpolicy(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%d\n", task->mosix.mask.migpolicy);
+	return(strlen(buffer));
+}
+
+int proc_pid_mignodes(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%08x\n", task->mosix.mask.mignodes);
+	return(strlen(buffer));
+}
+
+int proc_pid_miggroup(struct task_struct *task, char *buffer)
+{
+        sprintf(buffer, "%d\n", task->mosix.mask.miggroup);
+        return(strlen(buffer));
+}
+
+
+char *mosix_stay_string[] = {
+	"monkey",	"mmap_dev",	"VM86_mode",	"system",
+	"priv_inst",	"mem_lock",	"clone_vm",	"rt_sched",
+	"direct_io",	NULL,	"kiobuf",	NULL,
+	NULL,		NULL,		NULL,		NULL,
+	NULL,		NULL,		NULL,		NULL,
+	NULL,		NULL,		NULL,		NULL,
+	"extern_1",	"extern_2",	"extern_3",	"extern_4",
+	NULL,		NULL,		NULL,		"user_lock"
+};
+
+int proc_pid_cantmove(struct task_struct *task, char *buffer)
+{
+	typeof (task->mosix.stay) i;
+	unsigned int j;
+
+	for (buffer[0] = '\0' , j = 0 , i = 1 ; i ; i <<= 1 , j++)
+	if (task->mosix.stay & DSTAY & i)
+	{
+		if(buffer[0])
+			strcat(buffer, ", ");
+		strcat(buffer, mosix_stay_string[j] ? : "unrecognized");
+	}
+	if(buffer[0])
+		strcat(buffer, "\n");
+	return(strlen(buffer));
+}
+
+int proc_pid_nmigs(struct task_struct *task, char *buffer)
+{
+	task_lock(task);
+	sprintf(buffer, "%d\n", task->mosix.nmigs);
+	task_unlock(task);
+	return(strlen(buffer));
+}
+
+int proc_pid_sigmig(struct task_struct *task, char * buffer)
+{
+	sprintf(buffer, "%d\n", task->mosix.sigmig);
+	return(strlen(buffer));
+}
+
+#ifdef CONFIG_MOSIX_FS
+int proc_pid_selected(struct task_struct *task, char *buffer)
+{
+	sprintf(buffer, "%d\n", task->mosix.selected);
+	return(strlen(buffer));
+}
+#endif /* CONFIG_MOSIX_FS */
+
+void
+proc_get_stat_parts(struct task_struct *task, struct mm_struct *mm,
+					struct proc_remote_stat_parts *t)
+{
+	if (mm)
+	{
+		struct vm_area_struct *vma;
+
+		t->vsize = 0;
+		down_read(&mm->mmap_sem);
+		vma = mm->mmap;
+		while (vma) {
+			t->vsize += vma->vm_end - vma->vm_start;
+			vma = vma->vm_next;
+		}
+		t->rss = mm->rss;
+		t->start_code = mm->start_code;
+		t->end_code = mm->end_code;
+		t->start_stack = mm->start_stack;
+		up_read(&mm->mmap_sem);
+		if(task == current && (task->mosix.dflags & DREMOTE))
+		/* just in case EIP and/or ESP are held by DEPUTY: */
+			mosix_obtain_registers(
+				BIT_OF_REGISTER(eip)|BIT_OF_REGISTER(esp));
+		t->eip = KSTK_EIP(task);
+		t->esp = KSTK_ESP(task);
+	}
+	else
+		memset(t, 0, sizeof(*t));
+	t->priority = task->counter;
+	t->priority = 20 - (t->priority * 10 + DEF_COUNTER / 2) / DEF_COUNTER;
+	t->processor = task->processor;
+	if(task->mosix.dflags & DREMOTE)
+		t->processor += 32*PE;
+}
+#endif /* CONFIG_MOSIX */
+
 int proc_pid_stat(struct task_struct *task, char * buffer)
 {
+#ifdef CONFIG_MOSIX
+	unsigned long wchan;
+	long nice;
+	struct proc_remote_stat_parts rinfo;
+#else
 	unsigned long vsize, eip, esp, wchan;
 	long priority, nice;
+#endif /* CONFIG_MOSIX */
 	int tty_pgrp = -1, tty_nr = 0;
 	sigset_t sigign, sigcatch;
 	char state;
@@ -310,8 +481,36 @@
 	struct mm_struct *mm;
 
 	state = *get_task_state(task);
+#ifndef CONFIG_MOSIX
 	vsize = eip = esp = 0;
+#endif /* !CONFIG_MOSIX */
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if (task->tty) {
+		tty_pgrp = task->tty->pgrp;
+		tty_nr = kdev_t_to_nr(task->tty->device);
+	}
+	if(SHOULD_ASK_PROCESS(task))
+	{
+		task_unlock(task);
+		if(request_process(task, &rinfo, PR_PROCFS_GET_STAT_PARTS, 0)<0)
+			memset((caddr_t)&rinfo, 0, sizeof(rinfo));
+		mm = NULL;
+	}
+	else
+	{
+		mm = task->mm;
+		if(mm)
+			atomic_inc(&mm->mm_users);
+		task_unlock(task);
+		proc_get_stat_parts(task, mm, &rinfo);
+	}
+	/* the following test has nothing to do with MOSIX - just security! */
+	if ((current->fsuid != task->euid ||
+	    !cap_issubset(task->cap_permitted, current->cap_permitted)) &&
+	    !capable(CAP_DAC_OVERRIDE))
+		rinfo.eip = rinfo.esp = 0;
+#else
 	mm = task->mm;
 	if(mm)
 		atomic_inc(&mm->mm_users);
@@ -332,6 +531,7 @@
 		esp = KSTK_ESP(task);
 		up_read(&mm->mmap_sem);
 	}
+#endif /* CONFIG_MOSIX */
 
 	wchan = get_wchan(task);
 
@@ -339,8 +539,10 @@
 
 	/* scale priority and nice values from timeslices to -20..20 */
 	/* to make it look like a "normal" Unix priority/nice value  */
+#ifndef CONFIG_MOSIX
 	priority = task->counter;
 	priority = 20 - (priority * 10 + DEF_COUNTER / 2) / DEF_COUNTER;
+#endif /* !CONFIG_MOSIX */
 	nice = task->nice;
 
 	read_lock(&tasklist_lock);
@@ -366,19 +568,36 @@
 		task->times.tms_stime,
 		task->times.tms_cutime,
 		task->times.tms_cstime,
+#ifdef CONFIG_MOSIX
+		rinfo.priority,
+#else
 		priority,
+#endif /* CONFIG_MOSIX */
 		nice,
 		0UL /* removed */,
 		task->it_real_value,
 		task->start_time,
+#ifdef CONFIG_MOSIX
+		rinfo.vsize,
+		rinfo.rss,
+#else
 		vsize,
 		mm ? mm->rss : 0, /* you might want to shift this left 3 */
+#endif /* CONFIG_MOSIX */
 		task->rlim[RLIMIT_RSS].rlim_cur,
+#ifdef CONFIG_MOSIX
+		rinfo.start_code,
+		rinfo.end_code,
+		rinfo.start_stack,
+		rinfo.esp,
+		rinfo.eip,
+#else
 		mm ? mm->start_code : 0,
 		mm ? mm->end_code : 0,
 		mm ? mm->start_stack : 0,
 		esp,
 		eip,
+#endif /* CONFIG_MOSIX */
 		/* The signal information here is obsolete.
 		 * It must be decimal for Linux 2.0 compatibility.
 		 * Use /proc/#/status for real-time signals.
@@ -391,7 +610,12 @@
 		task->nswap,
 		task->cnswap,
 		task->exit_signal,
-		task->processor);
+#ifdef CONFIG_MOSIX
+		(int)rinfo.processor
+#else
+		task->processor
+#endif /* CONFIG_MOSIX */
+		);
 	if(mm)
 		mmput(mm);
 	return res;
@@ -476,12 +700,24 @@
 {
 	struct mm_struct *mm;
 	int size=0, resident=0, share=0, trs=0, lrs=0, drs=0, dt=0;
+#ifdef CONFIG_MOSIX
+	int should_ask = 0;
+#endif /* CONFIG_MOSIX */
 
 	task_lock(task);
+#ifdef CONFIG_MOSIX
+	if((should_ask = SHOULD_ASK_PROCESS(task)))
+		mm = NULL;
+	else
+#endif /* CONFIG_MOSIX */
 	mm = task->mm;
 	if(mm)
 		atomic_inc(&mm->mm_users);
 	task_unlock(task);
+#ifdef CONFIG_MOSIX
+	if(should_ask)
+		return(request_process(task, buffer, PR_PROCFS_GET_STATM, 0));
+#endif /* CONFIG_MOSIX */
 	if (mm) {
 		struct vm_area_struct * vma;
 		down_read(&mm->mmap_sem);
@@ -512,6 +748,44 @@
 		       size, resident, share, trs, lrs, drs, dt);
 }
 
+#ifdef CONFIG_MOSIX
+int proc_list_maps(struct vmamaps *maps, int start)
+{
+	struct mm_struct *mm;
+	struct vm_area_struct *map;
+	int i;
+
+	if (!(mm = current->mm))
+		return 0;
+	down_read(&mm->mmap_sem);
+	map = mm->mmap;
+	while (map && start-- > 0)
+		map = map->vm_next;
+	for (i = 0; map && i < PAGE_SIZE / sizeof(struct vmamaps); i++)
+	{
+		maps->vmstart = map->vm_start;
+		maps->vmend = map->vm_end;
+		maps->vmflags = map->vm_flags;
+		maps->vmpgoff = map->vm_pgoff;
+		maps->fp = map->vm_file ? home_file(map->vm_file) : 0;
+		maps++;
+		map = map->vm_next;
+	}
+	up_read(&mm->mmap_sem);
+	return i * sizeof(struct vmamaps);
+}
+
+void ref_mapped_files(struct vmamaps *maps, int len)
+{
+	unsigned int i;
+	struct file *fp;
+
+	for (i = 0; i < len / sizeof(struct vmamaps); i++)
+		if ((fp = maps[i].fp))
+			get_file(fp);
+}
+#endif /* CONFIG_MOSIX */
+
 static int show_map(struct seq_file *m, void *v)
 {
 	struct vm_area_struct *map = v;
@@ -607,6 +881,15 @@
 {
 	int i, len;
 
+#ifdef CONFIG_MOSIX
+	if(SHOULD_ASK_PROCESS(task))
+		request_process(task, buffer, PR_PROCFS_UPDATE_TIMES, 0);
+
+	if(task->mosix.nmigs) {
+                len += sprintf(buffer + len, "TIMES ON REMOTE CLUSTER NODES NOT LISTED\n");
+                return len;
+        }
+#endif /* CONFIG_MOSIX */
 	len = sprintf(buffer,
 		"cpu  %lu %lu\n",
 		task->times.tms_utime,
